<?php
namespace Magento\Pakkepost\Ui\Component\Listing\Column;

use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Framework\View\Element\UiComponent\ContextInterface;
use Magento\Ui\Component\Listing\Columns\Column;

class pkpProductRenderer extends Column
{
    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        array $components = [],
        array $data = []
    ) {
        parent::__construct($context, $uiComponentFactory, $components, $data);
    }

    public function prepareDataSource(array $dataSource)
    {
        if (isset($dataSource['data']['items'])) {
            foreach ($dataSource['data']['items'] as  & $item) {
                // Assuming 'pakkepost_product' is the column in your database table

                $item[$this->getData('name')] = $this->getMappedProductType(isset($item['pakkepost_product']) ? $item['pakkepost_product'] : null);
            }
        }

        return $dataSource;
    }

    // Function to get the product type from mapping
    public function getMappedProductType($productType)
    {

        $options = [
            '153' => __('Pakkepost Norge S'),
            '2005' => __('Norge M'),
            '2006' => __('Norge L'),
            '2007' => __('Norge XL'),
            '2011' => __('Bedrift S'),
            '2013' => __('Bedrift M'),
            '2012' => __('Bedrift L'),
            '2014' => __('Spesial L'),
            '2017' => __('Spesial XL'),
            '2024' => __('PostNord Medium'),
            '2025' => __('PostNord Stor'),
            '2026' => __('PostNord XL'),
            '2027' => __('PostNord XXL'),
            '2038' => __('PostNord Pakkeautomat'),
        ];
        if ($productType) {
            return $options[$productType];
        }
        return '';
    }
}
